UNICODE_STRING STRUCT
	xLength dw ?
	MaximumLength dw ?
	Buffer dd ?
UNICODE_STRING ENDS

PEB_LDR_DATA STRUCT 4
	xLength dd ?
	Initialized db ?
	SsHandle dd ?
	InLoadOrderModuleList LIST_ENTRY <>
	InMemoryOrderModuleList LIST_ENTRY <>
	InInitializationOrderModuleList LIST_ENTRY <>
PEB_LDR_DATA ENDS

PEB STRUCT
	InheritedAddressSpace db ?
	ReadImageFileExecOptions db ?
	BeingDebugged db ?
	Spare db ?
	Mutant dd ?
	ImageBaseAddress dd ?
	LoaderData dd ?
	ProcessParameters dd ?
	SubSystemData dd ?
	ProcessHeap dd ?
	FastPebLock dd ?
	FastPebLockRoutine dd ?
	FastPebUnlockRoutine dd ?
	EnvironmentUpdateCount dd ?
	KernelCallbackTable dd ?
	EventLogSection dd ?
	EventLog dd ?
	FreeList dd ?
	TlsExpansionCounter dd ?
	TlsBitmap dd ?
	TlsBitmapBits dd 2 dup(?)
	ReadOnlySharedMemoryBase dd ?
	ReadOnlySharedMemoryHeap dd ?
	ReadOnlyStaticServerData dd ?
	AnsiCodePageData dd ?
	OemCodePageData dd ?
	UnicodeCaseTableData dd ?
	NumberOfProcessors dd ?
	NtGlobalFlag dd ?
	Spare2 db 4 dup(?)
	CriticalSectionTimeout dq ?
	HeapSegmentCommit dd ?
	HeapDeCommitTotalFreeThreshold dd ?
	HeapDeCommitFreeBlockThreshold dd ?
	NumberOfHeaps dd ?
	MaximumNumberOfHeaps dd ?
	ProcessHeaps dd ?
	GdiSharedHandleTable dd ?
	ProcessStarterHelper dd ?
	GdiDCAttributeList dd ?
	LoaderLock dd ?
	OSMajorVersion dd ?
	OSMinorVersion dd ?
	OSBuildNumber dd ?
	OSPlatformId dd ?
	ImageSubSystem dd ?
	ImageSubSystemMajorVersion dd ?
	ImageSubSystemMinorVersion dd ?
	GdiHandleBuffer dd 22h dup(?)
	PostProcessInitRoutine dd ?
	TlsExpansionBitmap dd ?
	TlsExpansionBitmapBits db 80h dup(?)
	SessionId dd ?
PEB ENDS

LDR_MODULE STRUCT
	InLoadOrderModuleList LIST_ENTRY <>
	InMemoryOrderModuleList LIST_ENTRY <>
	InInitializationOrderModuleList LIST_ENTRY <>
	BaseAddress dd ?
	EntryPoint dd ?
	SizeOfImage dd ?
	FullDllName UNICODE_STRING <>
	BaseDllName UNICODE_STRING <>
	Flags dd ?
	LoadCount dw ?
	TlsIndex dw ?
	HashTableEntry LIST_ENTRY <>
	TimeDateStamp dd ?
LDR_MODULE ENDS


xinvoke MACRO name:REQ, params:VARARG
	count = 0
	FOR xparam, <params>
	  count = count + 1
	  @CatStr(var,%count) TEXTEQU @CatStr(&xparam)
	ENDM

	REPEAT count
	  IF @SizeStr(%@CatStr(var,%count)) GT 4
	    IFIDNI @SubStr(%@CatStr(var,%count), 1, 4),<addr>
	      __temp_text TEXTEQU @SubStr(%@CatStr(var,%count), 5)
	      lea eax, __temp_text
	      push eax
	    ELSE
	      push @CatStr(var,%count)
	    ENDIF
	  ELSE
	    push @CatStr(var,%count)
	  ENDIF

	  count = count - 1
	ENDM

	mov eax, name
	call eax
ENDM


noimport_invoke_load MACRO funcname:REQ, libname:REQ, params:VARARG
	count = 0
	_addr_found = 0
	_eax_found = 0
	FOR xparam, <params>
	  IFIDNI <&xparam>,<eax>
	    _eax_found = 1
	  ENDIF

	  count = count + 1
	  @CatStr(var,%count) TEXTEQU @CatStr(&xparam)
	ENDM

	REPEAT count
	  IF @SizeStr(%@CatStr(var,%count)) GT 4
	    IFIDNI @SubStr(%@CatStr(var,%count), 1, 4),<addr>
	      __temp_text TEXTEQU @SubStr(%@CatStr(var,%count), 5)
	      lea eax, __temp_text
	      push eax
	      _addr_found = 1
	    ELSE
	      push @CatStr(var,%count)
	    ENDIF
	  ELSE
	    push @CatStr(var,%count)
	  ENDIF

	  count = count - 1
	ENDM


	IF _addr_found EQ 1
	  IF _eax_found EQ 1
	    %ECHO [WARNING: EAX is used with ADDR at Line @CatStr(%@Line)]
	  ENDIF
	ENDIF

	xinvoke _LoadLibraryAFunc, libname
	xinvoke _GetProcAddressFunc, eax, funcname

	call eax
ENDM

noimport_invoke MACRO funcname:REQ, libname:REQ, params:VARARG
	count = 0
	_addr_found = 0
	_eax_found = 0
	FOR xparam, <params>
	  IFIDNI <&xparam>,<eax>
	    _eax_found = 1
	  ENDIF

	  count = count + 1
	  @CatStr(var,%count) TEXTEQU @CatStr(&xparam)
	ENDM

	REPEAT count
	  IF @SizeStr(%@CatStr(var,%count)) GT 4
	    IFIDNI @SubStr(%@CatStr(var,%count), 1, 4),<addr>
	      __temp_text TEXTEQU @SubStr(%@CatStr(var,%count), 5)
	      lea eax, __temp_text
	      push eax
	      _addr_found = 1
	    ELSE
	      push @CatStr(var,%count)
	    ENDIF
	  ELSE
	    push @CatStr(var,%count)
	  ENDIF

	  count = count - 1
	ENDM


	IF _addr_found EQ 1
	  IF _eax_found EQ 1
	    %ECHO [WARNING: EAX is used with ADDR at Line @CatStr(%@Line)]
	  ENDIF
	ENDIF


	xinvoke _GetModuleHandleA, libname
	xinvoke _GetProcAddressFunc, eax, funcname

	call eax
ENDM


noimport_call_prepare MACRO
	.data?
		_GetProcAddressFunc dd ?
		_LoadLibraryAFunc dd ?
		_GetModuleHandleA dd ?
		_krnl dd ?
	.code
		assume fs:nothing

		mov eax, fs:[30h]
		mov eax, PEB.LoaderData[eax]
		mov eax, PEB_LDR_DATA.InLoadOrderModuleList[eax]
		mov eax, LDR_MODULE.InLoadOrderModuleList[eax]
		mov eax, LDR_MODULE.InLoadOrderModuleList[eax]
		mov eax, LDR_MODULE.BaseAddress[eax]
		mov edx, eax
		mov _krnl, eax
		add eax, IMAGE_DOS_HEADER.e_lfanew
		mov eax, [eax]
		add eax, edx
		add eax, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress
		mov eax, [eax]
		add eax, edx
		mov edi, eax
		add eax, IMAGE_EXPORT_DIRECTORY.AddressOfNames
		mov eax, [eax]
		add eax, edx
		xor esi, esi

		__find:
			push eax
			mov eax, [eax]
			add eax, edx
			mov ebx, chr$("GetProcAddress")

			__compare:
				mov cl, [eax]
				mov ch, [ebx]
				test cl, cl
				jz __test_ch
				test ch, ch
				jz __next
				jmp __check

				__test_ch:
					test ch, ch
					jz __found
					jmp __next
				__check:
					cmp cl,ch
					jne __next

					inc eax
					inc ebx
					jmp __compare

		__next:
			inc esi
			pop eax
			add eax,4
			jmp __find
		__found:

		pop eax

		mov eax, edi
		add eax, IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals
		mov eax, [eax]
		add eax, edx
		add eax, esi
		add eax, esi
		mov bx, [eax]
		movzx ebx, bx
		mov eax, edi
		add eax, IMAGE_EXPORT_DIRECTORY.AddressOfFunctions
		mov eax, [eax]
		add eax, edx
		add ebx, ebx
		add eax, ebx
		add eax, ebx
		mov eax, [eax]
		add eax, edx
		mov _GetProcAddressFunc, eax

		xinvoke _GetProcAddressFunc, _krnl, chr$("LoadLibraryA")
		mov _LoadLibraryAFunc, eax

		xinvoke _GetProcAddressFunc, _krnl, chr$("GetModuleHandleA")
		mov _GetModuleHandleA, eax

		assume fs:error
ENDM